Page MenuHomePhabricator

[Regression] Blockquotes can't be edited, because they're alienated content
Closed, ResolvedPublic

Description

See https://en.wikipedia.org/wiki/User:Whatamidoing_(WMF)/sandbox?veaction=edit&section=1

This is the simplest possible blockquote, and it works around the limitations described in T86794: <blockquote> tags on different line from content of blockquote results alienated content. This should be editable (indeed, this blockquote was originally created in the visual editor), and it's not.

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptNov 9 2018, 5:13 PM

I think this is from the patch on T110004 which merged in mid-July, but based on the timeline wouldn't have actually rolled out to production until quite recently (see: T198511).

Based on the changes it made to parserTests.txt, I think Parsoid now always wraps the contents of blockquotes in paragraph tags.

@Esanders should we just improve our blockquote handling so that paragraphs inside blockquotes are editable? Or is there a reason for the alienation?

DLynch added a comment.Nov 9 2018, 5:47 PM

e.g. the parsoid HTML we get from the linked article is:

<blockquote id="mwEQ"><p id="mwEg">I am more and more convinced that poetry is the universal possession of mankind, revealing itself everywhere and at all times in hundreds and hundreds of men. . . . I therefore like to look about me in foreign nations, and advise everyone to do the same. National literature is now a rather unmeaning term; the epoch of world literature is at hand. – Johann Wolfgang von Goethe, 1827</p></blockquote>

To do that would mean making them BranchNodes, instead of ContentBranchNodes, and so affects a lot of things..

However this may be the best way to go ultimately, making blockquotes behave more like table cells, in that they have to contain a paragraph (and given a wrapper paragraph if none is present). This would also require changes to the FormatTool.

JTannerWMF triaged this task as Normal priority.Nov 20 2018, 4:13 PM
JTannerWMF edited projects, added VisualEditor (Current work); removed VisualEditor.
matmarex claimed this task.Nov 27 2018, 7:18 AM
matmarex removed matmarex as the assignee of this task.Nov 27 2018, 8:33 AM
matmarex edited projects, added VisualEditor; removed VisualEditor (Current work).

I submitted a patch on T76426, which would also resolve this issue. (Let's discuss it there.)

(Moving this task off the workboard in favor of that one, it's more convenient for me this way and I hope it makes no difference for you)

Esanders assigned this task to matmarex.Apr 9 2019, 12:46 PM
Ryasmeen edited projects, added Verified; removed Editing QA.May 7 2019, 8:11 PM
Ryasmeen moved this task from QA to Product owner review on the VisualEditor (Current work) board.

This is now resolved by the patches on T76426.

@ppelberg FYI, I closed all the related tasks (https://phabricator.wikimedia.org/maniphest/graph/76426/) so as not to clog up the workboard with 5 tasks for the same issue. Feel free to check them out when you're closing this one.

Got it, ok – thank you for the heads up, @matmarex.

ppelberg closed this task as Resolved.Jun 20 2019, 11:38 PM